(function ($, Drupal) {
    $("#zepto_config_btn").on("click",function(){
        $self = $(this);
        $.ajax({
            url: Drupal.url('admin/config/mail/zeptomail/saveconfig'),
            type: 'POST',
            dataType: 'json',
            data: {
              'domain' : $('[name=zepto_domain]').val(),
              'mailtoken' : $('#zepto_mail_token').val(),
              'from_address' : $("#zepto_from_address").val(),
              'from_name' : $("#zepto_from_name").val() ,
              'zepto_csrftoken' : $("#zepto_csrftoken").val()
            },
            beforeSend: function() {
							if($self.find(".loading-spinner").length === 0){
								$self.append($('<div>').addClass("loading-spinner"));
							}else {
								xhr.abort();
								return;
							}
            },
            success: function (data) {
              $self.find(".loading-spinner").remove();
							if(data.result === 'success'){
                addZMailSuccessMessage('Plugin configured successfully');
              } else {
                addZMailErrorMessage(data['error_message']);
              }
            }
          });

    });
    $("#zepto_test_btn").on("click",function(){
      $self = $(this);
      $.ajax({
          url: Drupal.url('admin/config/mail/zeptomail/testconfig'),
          type: 'POST',
          dataType: 'json',
          data: {
            'zepto_csrftoken' : $("#zepto_csrftoken").val()
          },
          beforeSend: function() {
            if($self.find(".loading-spinner").length === 0){
              $self.append($('<div>').addClass("loading-spinner"));
            }else {
              xhr.abort();
              return;
            }
          },
          success: function (data) {
            $self.find(".loading-spinner").remove();
            if(data.result === 'success'){
              addZMailSuccessMessage('Plugin configured successfully');
            } else {
              addZMailErrorMessage(data['error_message']);
            }
          }
        });

  });
  $("#zohomail_authorize_btn").on('click', function(){
    $self = $(this);
    $data = {};
    $data.clientId = $("#zohomail_client_id").val();
    $data.clientSecret = $("#zohomail_client_secret").val();
    $data.zohomail_csrftoken = $("#zohomail_csrftoken").val();
    $data.domain = $("[name=zohomail_domain]").val();
    $.ajax({
      url: Drupal.url('admin/config/mail/zohomail/authorize'),
      data: $data,
      type: 'POST',
      dataType: 'json',
      beforeSend: function() {
        if($self.find(".loading-spinner").length === 0){
          $self.append($('<div>').addClass("loading-spinner"));
        }else {
          xhr.abort();
          return;
        }
        $('label.zohomail_error').remove();
        $('.zohomail_error').removeClass('zohomail_error');
      },
      success: function(data, status, xhr) {
        $self.find(".loading-spinner").remove();
        if(data.result === 'success'){
          
          newWindow = window.open(data.authorize_url,'Zoho Mail','width=400,height=400');
          window.addEventListener('message', function(event) {
            $result = event.data;
            if($result.result === 'success'){
              addZMailSuccessMessage('Plugin configured successfully');
              window.location.reload();
            } else{
              console.log(event.data);
              addZMailErrorMessage('Invalid client secret');
              
              window.removeEventListener('message',function(event){});
            }
            
          });
          window.scrollTo(0,0);
        }
        else {
          if(data.hasOwnProperty('error_message')){
            addZMailErrorMessage(data['error_message']);
            window.scrollTo(0,0);
          }
          else if(data.hasOwnProperty('email_error')){
            $email_error = data.email_error;
            $.each($email_error,function(index,item){
              
              $label = $('<label>').attr("id",item['type']+"-error").addClass("zohomail_error").attr("for",item['type']).html(item['error']['message']);
              $('#'+item['type']).addClass('zohomail_error');
              $label.insertAfter($('[name='+item['type']+']'));
              
            });
            
          }
        }
        
      }
    });
    return false;
  });
  $('[purpose=copyredirecturi]').click(function(e) {
    var copyText = document.getElementById('zmail_redirection_url');
        copyText.select();
        copyText.setSelectionRange(0, copyText.value.length);
        document.execCommand('copy');
  });
  $('#zohomail_mailconfig_btn').on('click', function(e){
		$self = $(this);
    e.preventDefault();
    $from_address = $('#zmail_from_address').val();
    if($from_address === '' || $from_address === "-1") {
      addZMailErrorMessage('Configure email address');
      return;
    }
		$.ajax({
			url: Drupal.url('admin/config/mail/zohomail/saveEmailConfig'),
			data: {
				'zepto_csrftoken' : $("#zohomail_csrftoken").val(),
        'from_address' : $from_address
			},
			type: 'POST',
			dataType: 'json',
			beforeSend: function() {
				if($self.find(".loading-spinner").length === 0){
					$self.append($('<div>').addClass("loading-spinner"));
				}else {
					xhr.abort();
					return;
				}
				$('label.zohomail_error').remove();
				$('.zohomail_error').removeClass('zohomail_error');
			},
			success: function(data, status, xhr) {
				$self.find(".loading-spinner").remove();
				if(data.result == 'success'){
					addZMailSuccessMessage('Configuration working fine');
					$('[purpose=zmail_modify_config]').removeClass('zmail-dispNone');
				}
				else {
					if(data.hasOwnProperty('error_message')){
						addZMailErrorMessage(data['error_message']);
					}
					else if(data.hasOwnProperty('email_error')){
						$email_error = data.email_error;
						$.each($email_error,function(index,item){
									$error_data = item['error']['data'];
									$error_msg = '';
									if($error_data['moreInfo']) {
										$error_msg = $error_data['moreInfo'];
									}
									else if($error_data['errorCode']) {
										$error_msg = $error_data['errorCode'];
									}
									$label = $('<label>').attr("id",item['type']+"-error").addClass("zohomail_error").attr("for",item['type']).html($error_msg);
									$('#'+item['type']).addClass('zohomail_error');
									$label.insertAfter($('[name='+item['type']+']'));
						});
							
					}
				}
						
			}
		});
	});
  $('[purpose="configure-accordion"]').click(function(e){
    var $self = $(this);
    
    var $activeForm = $self.parent().siblings(".accordion-body");
    if(!$self.closest('[purpose=accordion-box]').hasClass('zmail-accordion-disabled')){
      $.each($activeForm,function(index,obj){
        if($(obj).attr("is_configured") === 1){
          $(obj).find('[purpose=configure-accordion]').addClass("zmailaccordion__trigger--configured");
        }
      });
      
      $self.removeClass("zmailaccordion__trigger--collapsed  zmailaccordion__trigger--configured").addClass("zmailaccordion__trigger--expanded");
      $self.parent().siblings(".accordion-body").removeClass("zmail-accordion-active").addClass("zmail-accordion-inactive");
      $self.parent(".accordion-body").removeClass("zmail-accordion-inactive").addClass("zmail-accordion-active");
    }
    
  });
  $('[purpose=reauthorize]').click(function(e) {
    e.preventDefault();
    $("[name=zohomail_domain]").removeAttr("disabled");
    $("#zohomail_client_id").removeAttr("disabled");
    $("#zohomail_client_secret").removeAttr("disabled");
    $("#zohomail_authorize_btn").removeClass("zmail-dispNone");
    $(this).addClass("zmail-dispNone");
  });
  $('[purpose=reconfigure]').click(function(e) {
    e.preventDefault();
    $("#zmail_from_address").removeAttr("disabled");
    $('#zmail_modify_config').addClass('zmail-dispNone');
    $('#zohomail_test_btn').addClass('zmail-dispNone');
    $('#zohomail_mailconfig_btn').removeClass('zmail-dispNone');
    $('[purpose=zmail_modify_config]').addClass('zmail-dispNone');
    
  });
  $('#zohomail_test_btn').on('click', function(e){
		$self = $(this);
    e.preventDefault();
    $from_address = $('#zmail_from_address').val();
    if($from_address === '' || $from_address === "-1") {
      addZMailErrorMessage('Configure email address');
      return;
    }
		$.ajax({
			url: Drupal.url('admin/config/mail/zohoomail/testEmailConfig'),
			data: {
				'zepto_csrftoken' : $("#zepto_csrftoken").val(),
        'from_address' : $from_address
			},
			type: 'POST',
			dataType: 'json',
			beforeSend: function() {
				if($self.find(".loading-spinner").length === 0){
					$self.append($('<div>').addClass("loading-spinner"));
				}else {
					xhr.abort();
					return;
				}
				$('label.zohomail_error').remove();
				$('.zohomail_error').removeClass('zohomail_error');
			},
			success: function(data, status, xhr) {
				$self.find(".loading-spinner").remove();
				if(data.result == 'success'){
					addZMailSuccessMessage('Configuration working fine');
					$('[purpose=zmail_modify_config]').removeClass('zmail-dispNone');
				}
				else {
					if(data.hasOwnProperty('error_message')){
						addZMailErrorMessage(data['error_message']);
					}
					else if(data.hasOwnProperty('email_error')){
						$email_error = data.email_error;
						$.each($email_error,function(index,item){
									$error_data = item['error']['data'];
									$error_msg = '';
									if($error_data['moreInfo']) {
										$error_msg = $error_data['moreInfo'];
									}
									else if($error_data['errorCode']) {
										$error_msg = $error_data['errorCode'];
									}
									$label = $('<label>').attr("id",item['type']+"-error").addClass("zohomail_error").attr("for",item['type']).html($error_msg);
									$('#'+item['type']).addClass('zohomail_error');
									$label.insertAfter($('[name='+item['type']+']'));
						});
							
					}
				}
						
			}
		});
	});
    
})(jQuery, Drupal);
  